typedef struct Element Element;
typedef struct Liste Liste;


enum Type
{
	PETITE_PLANTE=1,ARBRE=2,HERBIVORE=3,CARNIVORE=4
};

enum Etat
{
	INDEFINI=0,JEUNE=1,MOYEN=2,VIEUX=3,MORT=4,INEXISTANT=5
};

enum Action
{
	RIEN=0,REGROUPEMENT=1,ACCOUPLEMENT=2,MANGER=3,FUITE=4
};

typedef enum Type Type;
typedef enum Etat Etat;
typedef enum Action Action;


struct Liste
{
	short taille;
	Element *premier;
	Element *dernier;
};


struct Element
{
	enum Type type;
	short vie;
	short reproduction;

	//Animaux uniquement :
	short x;
	short y;
	char direction;
	char deplacement;
	
	signed short faim;
	enum Etat etat;
	
	char masse;
	char sante;
	char compteur;
	char viande;
	
	char nombre_predateurs;
	enum Action action;
	char objectif;
	enum Etat objectif_etat;
	Element *cible;
	Element *test;
	
	Element *suivant;
	Element *precedent;
};


//Fonctions de base :
void simulation();
Element *generation_map(short hauteur, short largeur,Liste *liste);
void affichage(Element etre);
void clear(short x,short y);
int alea(int min,int max);
char move(short x1,short y1,short *x2,short *y2,char distance,Element *carte,short hauteur,short largeur);
void erreur();
int abs(int nombre);

//Gestion de la liste chaînée :
Liste *initialisation();
void insertion(Liste *liste,short largeur,short hauteur,Element *carte,char hasard,short x,short y,Type type);
void suppression(Liste *liste,Element *element);

//Gestion des êtres :
void creation_etre(Element *etre,short largeur,short hauteur,Type type,Element *carte,char hasard,short x,short y);
void deplacement(Element *etre,short hauteur,short largeur,Element *carte);
void reproduction_vegetal(Liste *liste,Element *etre,short hauteur, short largeur,Element *carte);
void recherche(Element *etre,Element *carte,short hauteur,short largeur);
void objectif(Element *etre);
void action(Element *etre,short faim,Liste *liste,Element *carte,short largeur, short hauteur);
void ciblage(Element *etre,Element *cible);
